#include "common.h"
#include "backup.h"

extern HWND hProgress[2];

// GetSpecialPath will supports even Win95!
BOOL GetSpecialPath(HWND hWnd, int nFolder, LPSTR Path)
{
	ITEMIDLIST* idl;

	if(SHGetSpecialFolderLocation(hWnd, nFolder, &idl) != NOERROR)
		return FALSE;
	if(SHGetPathFromIDList(idl, Path) != NOERROR)
	{
		CoTaskMemFree(idl);
		return FALSE;
	}
	CoTaskMemFree(idl);

	cutEndYen(Path);

	return TRUE;
}

BOOL regularRegPath(LPTSTR path)
{
	TCHAR hive[32];
	TCHAR key[MAX_PATH];	// TODO: Not MAX_PATH
	LPCTSTR p;

	p = lstrchr(path, TEXT('\\'));

	if(!p)
		return FALSE;

	lstrcpyn(hive, path, ((p - path < 30) ? p - path : 30) + 1);

	key[0] = TEXT('\0');
	if(!lstrcmpi(hive, TEXT("HKCR")))	lstrcpy(key, TEXT("HKEY_CLASSES_ROOT"));
	if(!lstrcmpi(hive, TEXT("HKCU")))	lstrcpy(key, TEXT("HKEY_CURRENT_USER"));
	if(!lstrcmpi(hive, TEXT("HKLM")))	lstrcpy(key, TEXT("HKEY_LOCAL_MACHINE"));
	if(!lstrcmpi(hive, TEXT("HKU")))	lstrcpy(key, TEXT("HKEY_USERS"));
	if(!lstrcmpi(hive, TEXT("HKEY_CLASSES_ROOT")))	lstrcpy(key, TEXT("HKEY_CLASSES_ROOT"));
	if(!lstrcmpi(hive, TEXT("HKEY_CURRENT_USER")))	lstrcpy(key, TEXT("HKEY_CURRENT_USER"));
	if(!lstrcmpi(hive, TEXT("HKEY_LOCAL_MACHINE")))	lstrcpy(key, TEXT("HKEY_LOCAL_MACHINE"));
	if(!lstrcmpi(hive, TEXT("HKEY_USERS")))			lstrcpy(key, TEXT("HKEY_USERS"));

	// HKEY_PERFORMANCE_DATA HKEY_CURRENT_CONFIG HKEY_DYN_DATA are have not been supported.

	lstrcat(key, p);

	if(lstrlen(key))
	{
		lstrcpy(path, key);
		return TRUE;
	}else
		return FALSE;
}

void expandPercents(LPTSTR str)
{
	TCHAR ts[MAX_PATH];
	LPTSTR p = str;
	LPTSTR q;

	ts[0] = TEXT('\0');

	if(!lstrchr(p, TEXT('%')))	// No %, not required expand.
		return;

	while(q = (LPTSTR)lstrchr(p, TEXT('%')))
	{
		LPTSTR r = (LPTSTR)lstrchr(CharNext(q), TEXT('%'));

		if(q - p)
			lstrcpyn(ts + lstrlen(ts), p, q - p + 1);

		if(!r)
		{	// illegal end, but cover.
			lstrcat(ts, p);
			break;
		}

		if(r - q == 1)
		{
			// "%%"
			lstrcat(ts, TEXT("%"));
		}else
		{
			// "%...%"
			TCHAR key[30];

			lstrcpyn(key, q + 1, ((r - (q + 1)) < 30 ? (r - (q + 1)) : 30) + 1);

			//if(!lstrcmpi(key, TEXT("AllUsersProfile")))
			//	GetSpecialPath(NULL, CSIDL_COMMON_APPDATA, ts + lstrlen(ts));	// Shell32 5.0 or later
			if(!lstrcmpi(key, TEXT("AppData")))
				GetSpecialPath(NULL, CSIDL_APPDATA, ts + lstrlen(ts));	// Shell32 4.71 or later
			if(!lstrcmpi(key, TEXT("AllUsersAppData")))
				GetSpecialPath(NULL, CSIDL_COMMON_APPDATA, ts + lstrlen(ts));	// Shell32 5.0 or later
			if(!lstrcmpi(key, TEXT("ProgramFilesCommon")))
				GetSpecialPath(NULL, CSIDL_PROGRAM_FILES_COMMON, ts + lstrlen(ts));	// Shell32 5.0 or later, and WIN2k/XP
			if(!lstrcmpi(key, TEXT("HomePath")) || !lstrcmpi(key, TEXT("UserProfile")))
				GetSpecialPath(NULL, CSIDL_PROFILE, ts + lstrlen(ts));	// Shell32 5.0 or later
			if(!lstrcmpi(key, TEXT("ProgramFiles")))
				GetSpecialPath(NULL, CSIDL_PROGRAM_FILES, ts + lstrlen(ts));	// Shell32 5.0 or later
			if(!lstrcmpi(key, TEXT("SystemRoot")) || !lstrcmpi(key, TEXT("Windir")))
				GetSpecialPath(NULL, CSIDL_WINDOWS, ts + lstrlen(ts));	// Shell32 5.0 or later
			//if(!lstrcmpi(key, TEXT("SystemDrive")))
			//	GetSpecialPath(NULL, CSIDL_WINDOWS, ts + lstrlen(ts));	// Shell32 5.0 or later

			if(lstrchr(key, TEXT('\\')))
				*(LPTSTR)lstrchr(key, TEXT('\\')) = TEXT('\0');

			if((lstrlen(key) == 4 && !lstrcmpni(key, TEXT("HK"), 2)) || !lstrcmpni(key, TEXT("HKEY"), 4))
			{
				LPTSTR regpath;

				regpath = halloc(r - (q + 1) + 30 + 1);	// "+30" for regular regpath.(HKCU->HKEY_CURRENT_USER etc.)
				lstrcpyn(regpath, q + 1, r - (q + 1) + 1);
				if(regularRegPath(regpath))
				{
					LPTSTR nx;
					HKEY hreg;
					LPTSTR valname;
					LPTSTR val;
					DWORD valsize;
					DWORD valtype;

					nx = (LPTSTR)lastchar(regpath, TEXT('\\'));
					valname = CharNext(nx);
					*nx = TEXT('\0');

					if(RegOpenKeyEx(getHKeyFromString(regpath), CharNext(lstrchr(regpath, TEXT('\\'))), 0, KEY_READ, &hreg))
					{
						MessageBox(NULL, valname, AllocLoadString(IDS_ERROR_CANTOPENREGKEYANDSKIP), MB_ICONERROR | MB_OK);
					}else
					{
						if(RegQueryValueEx(hreg, valname, 0, &valtype, NULL, &valsize))
						{
							MessageBox(NULL, valname, AllocLoadString(IDS_ERROR_CANTREADREGVALUEANDSKIP), MB_ICONERROR | MB_OK);
						}else
						{
							if(valtype == REG_SZ || valtype == REG_EXPAND_SZ)
							{
								val = halloc(valsize);
								RegQueryValueEx(hreg, valname, 0, NULL, val, &valsize);
								lstrcat(ts,val);
								hfree(val);
							}else
							{
								MessageBox(NULL, valname, AllocLoadString(IDS_ERROR_ILLEGALREGVALTYPEANDSKIP), MB_ICONERROR | MB_OK);
							}
						}
						RegCloseKey(hreg);
					}
				}
				hfree(regpath);
			}
		}

		p = CharNext(r);
	}

	if(!q)	// if [not "not exist %" break]
		lstrcat(ts, p);

	lstrcpy(str, ts);

	return;
}

/*
		if get="allusersprofile":getsysfol gpath,35:pprm+=gpath+"\\.."
		if get="appdata":getsysfol gpath,26:pprm+=gpath
		if get="allusersappdata":getsysfol gpath,35:pprm+=gpath
		if get="commonprogramfiles":getsysfol gpath,43:pprm+=gpath
		if get="homepath":getsysfol gpath,40:pprm+=gpath
		if get="programfiles":getsysfol gpath,38:pprm+=gpath
		if get="systemdrive":getsysfol gpath,36:strmid gpath,gpath,0,2:pprm+=gpath
		if get="systemroot":getsysfol gpath,36:pprm+=gpath
		if get="userprofile":getsysfol gpath,40:pprm+=gpath
		if get="windir":getsysfol gpath,36:pprm+=gpath
		strmid gpath,get,0,4
		if gpath="hkey"{
			inyen get,0
			strmid gpath,get,0,stat
			if gpath="hkey_current_user":v=0
			if gpath="hkey_local_machine":v=1
			if gpath="hkey_users":v=2
			if gpath="hkey_classes_root":v=3
			strlen l,get:strmid gpath,get,stat+1,l-stat-1
			sdim tmp,256
			endyen gpath
			strlen l,gpath:strmid tmp,gpath,stat+1,l-stat-1
			strmid gpath,gpath,0,stat

			regopenkey v,gpath,0,1
			reggetvalue gpath,tmp,1024
			regclosekey

			pprm+=gpath
		}
		if get="":pprm+="%"
		isendyen pprm:if stat:strlen l,pprm:strmid pprm,pprm,0,l-1

		i+=j+1
	loop
	strlen l,prm
	strmid get,prm,i,l-i:pprm+=get
	sdim prm,32768:prm=pprm

	sdim pprm,64:sdim get,256:sdim gpath,64

	return

;getsysfol param.
;
;35\..		ALLUSERSPROFILE=C:\Documents and Settings\All Users
;26		APPDATA=C:\Documents and Settings\Murachue\Application Data
;43		CommonProgramFiles=C:\Program Files\Common Files
;40		HOMEPATH=\Documents and Settings\Murachue
;38		ProgramFiles=C:\Program Files
;36(getpath)	SystemDrive=C:
;36		SystemRoot=C:\WINDOWS
;40		USERPROFILE=C:\Documents and Settings\Murachue
;36		windir=C:\WINDOWS
*/

BOOL dirCopy(HWND dlg, LPCTSTR src, LPCTSTR dst, BOOL subdir)
{
	TCHAR predir[MAX_PATH];
	HANDLE hfind;
	WIN32_FIND_DATA wfd;

	TCHAR dir[MAX_PATH], filter[MAX_PATH];
	TCHAR destdir[MAX_PATH];

	lstrcpy(dir, src);
	*(LPTSTR)basename(dir) = TEXT('\0');
	lstrcpy(filter, basename(src));
	lstrcpy(destdir, dst);
	addEndYen(destdir);

	GetCurrentDirectory(sizeof(predir), predir);
	SetCurrentDirectory(dir);

	if(hfind = FindFirstFile(filter, &wfd))
	{
		UINT files;
		UINT count = 1;

		{
			MSG msg;

			while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}

		SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, 100));
		SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETPOS, 0, 0);

		{
			HANDLE hfind;
			WIN32_FIND_DATA wfd;

			files = 0;

			hfind = FindFirstFile(filter, &wfd);

			do
			{
				files++;
			}while(FindNextFile(hfind, &wfd));

			FindClose(hfind);
		}

		do
		{
			if(!lstrcmp(wfd.cFileName, TEXT(".")))
				continue;
			if(!lstrcmp(wfd.cFileName, TEXT("..")))
				continue;

			if(wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
			{
				if(subdir)
				{
					TCHAR src[MAX_PATH], dstdir[MAX_PATH];

					lstrcpy(src, dir);
					addEndYen(src);
					lstrcat(src, wfd.cFileName);
					addEndYen(src);
					lstrcat(src, filter);

					lstrcpy(dstdir, destdir);
					addEndYen(dstdir);
					lstrcat(dstdir, wfd.cFileName);
					addEndYen(dstdir);

					makedir(dstdir);

					if(dirCopy(dlg, src, dstdir, subdir))
					{
						DWORD le = GetLastError();

						FindClose(hfind);
						SetCurrentDirectory(predir);
						SetLastError(le);

						return TRUE;
					}

					SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETPOS, count * 100 / files, 0);
				}
			}else
			{
				// FileCopy
				TCHAR srcf[MAX_PATH], dstf[MAX_PATH];

				lstrcpy(srcf, dir);
				lstrcat(srcf, wfd.cFileName);

				lstrcpy(dstf, destdir);
				lstrcat(dstf, wfd.cFileName);

				SetDlgItemText(dlg, IDC_PROCTEXT, srcf);

				// TODO: error check
				CopyFile(srcf, dstf, FALSE);

				SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETPOS, count * 100 / files, 0);

				// SetFileAttributeȂĂCopyFileł?
			}
			count++;
		}while(FindNextFile(hfind, &wfd));
		FindClose(hfind);
	}

	SetCurrentDirectory(predir);

	return FALSE;
}

BOOL CALLBACK ProcstatusDlgProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	return FALSE;
}

BOOL backupSubProc(LPCTSTR file, LPCTSTR outdir, BOOL sub)
{
	TCHAR src[MAX_PATH];
	HWND dlg;
	BOOL ret;

	dlg = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_PROCSTATUS), NULL, ProcstatusDlgProc);
	SetWindowText(dlg, AllocLoadString(IDS_CAPTION_COPYINGFILE));
	ShowWindow(dlg, SW_SHOWNOACTIVATE);

	lstrcpy(src, file);
	expandPercents(src);

	makedir(outdir);

	ret = dirCopy(dlg, src, outdir, sub);

	{
		DWORD le = GetLastError();
		DestroyWindow(dlg);
		SetLastError(le);
	}

	return ret;
}

void escapeYens(LPTSTR string)
{
	LPTSTR escaped;
	LPTSTR p, q;

	escaped = halloc((lstrlen(string) + 1) * sizeof(TCHAR) * 2);
	escaped[0] = TEXT('\0');

	for(p = string; q = (LPTSTR)lstrchr(p, TEXT('\\')); p = CharNext(q))
	{
		lstrcpyn(escaped + lstrlen(escaped), p, q - p + 1);
		lstrcat(escaped, TEXT("\\\\"));
	}
	lstrcpyn(escaped + lstrlen(escaped), p, escaped + lstrlen(escaped) - p + 1);
	lstrcpy(string, escaped);

	escaped[0] = TEXT('\0');
	for(p = string; q = (LPTSTR)lstrchr(p, TEXT('"')); p = CharNext(q))
	{
		lstrcpyn(escaped + lstrlen(escaped), p, q - p + 1);
		lstrcat(escaped, TEXT("\\\""));
	}
	lstrcpyn(escaped + lstrlen(escaped), p, escaped + lstrlen(escaped) - p + 1);
	lstrcpy(string, escaped);

	hfree(escaped);

	return;
}

// Save use REGEDIT4 format.
BOOL saveReg4(HWND dlg, LPCTSTR path, LPTSTR* buf, UINT* bufsize)
{
	HKEY root;
	LPCTSTR key;
	HKEY hreg;

	if(!(root = getHKeyFromString(path)))
		return FALSE;

	key = CharNext(lstrchr(path, TEXT('\\')));

	if(!key)
		return FALSE;

	if(SetLastErrorReturn(RegOpenKeyEx(root, key, 0, KEY_READ, &hreg)))	// Zero=Success, NonZero=ERROR!
		return FALSE;

	do
	{
		DWORD valuecount;
		LPTSTR valname = NULL;
		DWORD maxvalnamesize;
		LPTSTR valdata = NULL;
		DWORD maxvaldatasize;

		DWORD subkeycount;
		LPTSTR subkey = NULL;
		DWORD maxsubkeysize;

		UINT i;

		RegQueryInfoKey(hreg, NULL, 0, 0, &subkeycount, &maxsubkeysize, NULL, &valuecount, &maxvalnamesize, &maxvaldatasize, NULL, NULL);

		maxvalnamesize *= 4;	// for escaping+ansi
		maxvalnamesize++;
		maxvaldatasize *= 4;	// for escaping+ansi
		maxvaldatasize++;
		maxsubkeysize *= 2;	// for ansi
		maxsubkeysize++;	// subkey can't contain '\', no escape required.

		if(dlg)
		{
			SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, 100));
			SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETPOS, 0, 0);
		}

		{
			TCHAR pt[MAX_PATH];	// TODO: Not MAX_PATH

			appendString(buf, bufsize, TEXT("[-"));
			lstrcpy(pt, path);
			regularRegPath(pt);
			appendString(buf, bufsize, pt);
			appendString(buf, bufsize, TEXT("]\r\n"));

			appendString(buf, bufsize, TEXT("["));
			lstrcpy(pt, path);
			regularRegPath(pt);
			appendString(buf, bufsize, pt);
			appendString(buf, bufsize, TEXT("]\r\n"));

			if(dlg)
				SetDlgItemText(dlg, IDC_PROCTEXT, pt);
		}

		if(valuecount)
		{
			if(!(valname = halloc(maxvalnamesize)))	goto Error;
			if(!(valdata = halloc(maxvaldatasize)))	goto Error;

			for(i = 0; i < valuecount; i++)
			{
				DWORD valnamesize = maxvalnamesize, valdatasize = maxvaldatasize;
				DWORD valtype;
				DWORD lastlineoffset;

				{
					MSG msg;

					while(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
					{
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
				}

				if(RegEnumValue(hreg, i, valname, &valnamesize, 0, &valtype, valdata, &valdatasize))
					goto Error;

				lastlineoffset = lstrlen(*buf);

				if(lstrlen(valname))
				{	// normal
					appendString(buf, bufsize, TEXT("\""));
					escapeYens(valname);
					appendString(buf, bufsize, valname);
					appendString(buf, bufsize, TEXT("\"="));
				}else	// Default
					appendString(buf, bufsize, TEXT("@="));

				switch(valtype)
				{
				case REG_SZ:
					appendString(buf, bufsize, TEXT("\""));
					escapeYens(valdata);
					appendString(buf, bufsize, valdata);
					appendString(buf, bufsize, TEXT("\""));
					break;
				case REG_DWORD:
					{
						TCHAR ts[64];

						wsprintf(ts, TEXT("dword:%08x"), *(DWORD*)valdata);
						appendString(buf, bufsize, ts);
					}
					break;
				default:
					{
						TCHAR ts[17];
						UINT i;

						appendString(buf, bufsize, TEXT("hex"));
						if(valtype != REG_BINARY)
						{
							wsprintf(ts, TEXT("(%x)"), valtype);
							appendString(buf, bufsize, ts);
						}
						appendString(buf, bufsize, TEXT(":"));

						for(i = 0; i < valdatasize; i++)
						{
							wsprintf(ts, TEXT("%02x"), ((BYTE*)valdata)[i]);
							if(i < valdatasize - 1)
								lstrcat(ts, ",");
							appendString(buf, bufsize, ts);
							// TODO: FATAL: appendStringbuf\->lastlineobsolete
							if(80 < lstrlen(*buf + lastlineoffset) + 3 + 1)
							//if((i + 1) == nextret)	// !((i + 1) % 20)
							{
								appendString(buf, bufsize, TEXT("\\\r\n"));
								lastlineoffset = lstrlen(*buf);
								appendString(buf, bufsize, TEXT("  "));
							}
						}
					}
					break;
				}

				appendString(buf, bufsize, TEXT("\r\n"));

				if(dlg)
					SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETPOS, i * 100 / valuecount, 0);
			}

			hfree(valname), valname=NULL;
			hfree(valdata), valdata=NULL;
		}

		appendString(buf, bufsize, TEXT("\r\n"));

		if(subkeycount && maxsubkeysize)
		{
			if(!(subkey = halloc(maxsubkeysize)))	goto Error;

			for(i = 0; i < subkeycount; i++)
			{
				DWORD subkeysize = maxsubkeysize;
				TCHAR nxpath[MAX_PATH];	// TODO: Not MAX_PATH. True value is...?

				if(RegEnumKeyEx(hreg, i, subkey, &subkeysize, 0, NULL, NULL, NULL))
					goto Error;

				lstrcpy(nxpath, path);
				addEndYen(nxpath);
				lstrcat(nxpath, subkey);

				if(!saveReg4(dlg, nxpath, buf, bufsize))
					break;
			}

			hfree(subkey), subkey=NULL;
		}

		break;
Error:
		{
			DWORD le = GetLastError();
			if(valname)	hfree(valname);
			if(valdata)	hfree(valdata);
			if(subkey)	hfree(subkey);
			RegCloseKey(hreg);
			SetLastError(le);
		}
		return FALSE;
	}while(0);

	RegCloseKey(hreg);

	return TRUE;
}

BOOL backupReg(LPCTSTR regpath, LPCTSTR outdir, BOOL useRegedit)
{
	LPTSTR buf;
	UINT bsize;
	HWND dlg;
	TCHAR rpath[MAX_PATH];	// TODO: MAX_PATH is incorrect...

	if(useRegedit)
	{
		TCHAR savefname[MAX_PATH];
		TCHAR param[MAX_PATH * 2];	// TODO: Not MAX_PATH

		lstrcpy(savefname, outdir);
		cutEndYen(savefname);
		lstrcat(savefname, TEXT(".reg"));

		lstrcpy(param, TEXT("/e \""));
		lstrcat(param, savefname);
		lstrcat(param, TEXT("\" \""));
		lstrcat(param, regpath);
		lstrcat(param, TEXT("\""));

		ShellExecute(NULL, NULL, "regedit", param, NULL, SW_HIDE);

		return FALSE;
	}

	dlg = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_PROCSTATUS), NULL, ProcstatusDlgProc);
	SetWindowText(dlg, AllocLoadString(IDS_CAPTION_EXPORTINGREG));
	ShowWindow(dlg, SW_SHOWNOACTIVATE);

	newString(&buf, &bsize);

	// TODO: OSf->Regedit5ŏo
	lstrcpy(buf, TEXT("REGEDIT4\r\n\r\n"));

	lstrcpy(rpath, regpath);
	expandPercents(rpath);

	if(!saveReg4(dlg, rpath, &buf, &bsize))
	{
		DWORD le = GetLastError();
		hfree(buf);
		DestroyWindow(dlg);
		SetLastError(le);
		return TRUE;
	}

	{
		TCHAR savefname[MAX_PATH];
		HANDLE hf = NULL;

		lstrcpy(savefname, outdir);
		cutEndYen(savefname);
		lstrcat(savefname, TEXT(".reg"));

		do
		{
			DWORD written;

			if((hf = CreateFile(savefname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE)
				goto Error;

			if(!WriteFile(hf, buf, lstrlen(buf) * sizeof(TCHAR), &written, NULL))
				written = 0;

			if(written < lstrlen(buf) * sizeof(TCHAR))
				goto Error;

			CloseHandle(hf);
			break;
Error:
			{
				DWORD le = GetLastError();
				if(hf)	CloseHandle(hf);
				hfree(buf);
				DestroyWindow(dlg);
				SetLastError(le);
			}
			return TRUE;
		}while(0);
	}

	hfree(buf);

	DestroyWindow(dlg);

	return FALSE;
}

BOOL backupRelation(LPCTSTR exename, LPCTSTR outdir, BOOL useRegedit)
{
	// TODO: dۑȂƂ
	LPTSTR buf;
	UINT bsize;
	HWND dlg;

	dlg = CreateDialog(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_PROCSTATUS), NULL, ProcstatusDlgProc);
	SetWindowText(dlg, AllocLoadString(IDS_CAPTION_EXPORTINGRELATION));
	ShowWindow(dlg, SW_SHOWNOACTIVATE);

	{
		TCHAR caption[MAX_PATH];

		wsprintf(caption, AllocLoadString(IDS_STATUS_SAVINGRELATIONOF), exename);
		SetDlgItemText(dlg, IDC_PROCTEXT, caption);
	}

	newString(&buf, &bsize);

	// TODO: OSf->Regedit5ŏo
	lstrcpy(buf, TEXT("REGEDIT4\r\n\r\n; Relation with "));
	lstrcat(buf, exename);
	lstrcat(buf, TEXT("\r\n\r\n"));

	{
		HKEY hreg, hcr;

		DWORD i;
		DWORD keycount;
		DWORD maxkeynamesize;
		LPTSTR keyname;

		SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETRANGE, 0, MAKELPARAM(0, 100));
		SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETPOS, 0, 0);

		{
			if(RegOpenKeyEx(HKEY_CLASSES_ROOT, TEXT(""), 0, KEY_READ, &hreg))
				return FALSE;

			RegQueryInfoKey(hreg, NULL, NULL, NULL, &keycount, &maxkeynamesize, NULL, NULL, NULL, NULL, NULL, NULL);

			keyname = halloc((maxkeynamesize + 1) * sizeof(TCHAR));

			for(i = 0; i < keycount; i++)
			{
				DWORD keynamesize = maxkeynamesize;

				RegEnumKeyEx(hreg, i, keyname, &keynamesize, NULL, NULL, NULL, NULL);

				SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETPOS, i * 50 / keycount, 0);

				if(keyname[0] == TEXT('.'))
				{
					HKEY hr, hr2;
					LPTSTR vdata;
					DWORD vsize;

					RegOpenKeyEx(hreg, keyname, 0, KEY_READ, &hr);
					RegQueryValueEx(hr, TEXT(""), NULL, NULL, NULL, &vsize);
					vdata = halloc(vsize + lstrlen(TEXT("\\shell")));	// vsizeNULL
					RegQueryValueEx(hr, TEXT(""), NULL, NULL, vdata, &vsize);
					lstrcat(vdata, TEXT("\\shell"));
					RegCloseKey(hr);

					if(RegOpenKeyEx(hreg, vdata, 0, KEY_READ, &hr))
					{
						hfree(vdata);
						continue;	// No entry...
					}
					hfree(vdata);
					if(!RegQueryValueEx(hr, TEXT(""), NULL, NULL, NULL, &vsize) && vsize != 1)
					{
						vdata = halloc(vsize + lstrlen(TEXT("\\command")));	// vsizeNULL
						RegQueryValueEx(hr, TEXT(""), NULL, NULL, vdata, &vsize);
					}else
					{
						vsize = lstrlen(TEXT("open")) + sizeof(TCHAR);
						vdata = halloc(vsize + lstrlen(TEXT("\\command")));	// vsizeNULL
						lstrcpy(vdata, TEXT("open"));
					}
					lstrcat(vdata, TEXT("\\command"));

					if(RegOpenKeyEx(hr, vdata, 0, KEY_READ, &hr2))
					{
						hfree(vdata);
						continue;	// No command...
					}
					hfree(vdata);
					RegQueryValueEx(hr2, TEXT(""), NULL, NULL, NULL, &vsize);
					vdata = halloc(vsize);	// vsizeNULL
					RegQueryValueEx(hr2, TEXT(""), NULL, NULL, vdata, &vsize);
					RegCloseKey(hr2);
					RegCloseKey(hr);

					if(lstrstri(vdata, exename))
					{
						TCHAR kn[MAX_PATH];	// TODO: MAX_PATH is incorrect

						{
							TCHAR caption[MAX_PATH];

							wsprintf(caption, AllocLoadString(IDS_STATUS_SAVINGRELATIONOF_WRITING), exename, keyname);
							SetDlgItemText(dlg, IDC_PROCTEXT, caption);
						}

						lstrcpy(kn, TEXT("HKEY_CLASSES_ROOT\\"));
						lstrcat(kn, keyname);
						saveReg4(NULL, kn, &buf, &bsize);

						hfree(vdata);
						RegOpenKeyEx(hreg, keyname, 0, KEY_READ, &hr);
						RegQueryValueEx(hr, TEXT(""), NULL, NULL, NULL, &vsize);
						vdata = halloc(vsize);	// vsizeNULL
						RegQueryValueEx(hr, TEXT(""), NULL, NULL, vdata, &vsize);
						RegCloseKey(hr);
						lstrcpy(kn, TEXT("HKEY_CLASSES_ROOT\\"));
						lstrcat(kn, vdata);
						saveReg4(NULL, kn, &buf, &bsize);

						{
							TCHAR caption[MAX_PATH];

							wsprintf(caption, AllocLoadString(IDS_STATUS_SAVINGRELATIONOF_WROTE), exename, keyname);
							SetDlgItemText(dlg, IDC_PROCTEXT, caption);
						}
					}

					hfree(vdata);
				}
			}

			hfree(keyname);

			RegCloseKey(hreg);
		}

		{
			if(RegOpenKeyEx(HKEY_CLASSES_ROOT, TEXT(""), 0, KEY_READ, &hcr))
				return TRUE;

			if(RegOpenKeyEx(HKEY_CURRENT_USER, TEXT("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts"), 0, KEY_READ, &hreg))
			{
				DWORD le = GetLastError();
				RegCloseKey(hcr);
				SetLastError(le);
				return TRUE;
			}

			RegQueryInfoKey(hreg, NULL, NULL, NULL, &keycount, &maxkeynamesize, NULL, NULL, NULL, NULL, NULL, NULL);

			keyname = halloc((maxkeynamesize + 1) * sizeof(TCHAR));

			for(i = 0; i < keycount; i++)
			{
				DWORD keynamesize = maxkeynamesize;

				RegEnumKeyEx(hreg, i, keyname, &keynamesize, NULL, NULL, NULL, NULL);

				SendMessage(GetDlgItem(dlg, IDC_PROCPROGRESS), PBM_SETPOS, 50 + i * 50 / keycount, 0);

				if(keyname[0] == TEXT('.'))	// FileExts͐擪S"."Ȃ񂾂ǁB
				{
					HKEY hr, hr2;
					LPTSTR vdata;
					DWORD vsize;

					RegOpenKeyEx(hreg, keyname, 0, KEY_READ, &hr);
					if(RegQueryValueEx(hr, TEXT("ProgID"), NULL, NULL, NULL, &vsize))
						continue;
					vdata = halloc(vsize + lstrlen(TEXT("\\shell")));	// vsizeNULL
					RegQueryValueEx(hr, TEXT("ProgID"), NULL, NULL, vdata, &vsize);
					lstrcat(vdata, TEXT("\\shell"));
					RegCloseKey(hr);

					if(RegOpenKeyEx(hcr, vdata, 0, KEY_READ, &hr))
					{
						hfree(vdata);
						continue;	// No entry...
					}
					hfree(vdata);
					if(!RegQueryValueEx(hr, TEXT(""), NULL, NULL, NULL, &vsize) && vsize != 1)
					{
						vdata = halloc(vsize + lstrlen(TEXT("\\command")));	// vsizeNULL
						RegQueryValueEx(hr, TEXT(""), NULL, NULL, vdata, &vsize);
					}else
					{
						vsize = lstrlen(TEXT("open")) + sizeof(TCHAR);
						vdata = halloc(vsize + lstrlen(TEXT("\\command")));	// vsizeNULL
						lstrcpy(vdata, TEXT("open"));
					}
					lstrcat(vdata, TEXT("\\command"));

					if(RegOpenKeyEx(hr, vdata, 0, KEY_READ, &hr2))
					{
						hfree(vdata);
						continue;	// No command...
					}
					hfree(vdata);
					RegQueryValueEx(hr2, TEXT(""), NULL, NULL, NULL, &vsize);
					vdata = halloc(vsize);	// vsizeNULL
					RegQueryValueEx(hr2, TEXT(""), NULL, NULL, vdata, &vsize);
					RegCloseKey(hr2);
					RegCloseKey(hr);

					if(lstrstri(vdata, exename))
					{
						TCHAR kn[MAX_PATH];	// TODO: MAX_PATH is incorrect

						{
							TCHAR caption[MAX_PATH];

							wsprintf(caption, AllocLoadString(IDS_STATUS_SAVINGRELATIONOF_WRITING), exename, keyname);
							SetDlgItemText(dlg, IDC_PROCTEXT, caption);
						}

						lstrcpy(kn, TEXT("HKEY_CURRENT_USER\\Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\FileExts\\"));
						lstrcat(kn, keyname);
						saveReg4(NULL, kn, &buf, &bsize);

						hfree(vdata);
						RegOpenKeyEx(hreg, keyname, 0, KEY_READ, &hr);
						RegQueryValueEx(hr, TEXT("ProgID"), NULL, NULL, NULL, &vsize);
						vdata = halloc(vsize);	// vsizeNULL
						RegQueryValueEx(hr, TEXT("ProgID"), NULL, NULL, vdata, &vsize);
						RegCloseKey(hr);
						lstrcpy(kn, TEXT("HKEY_CLASSES_ROOT\\"));
						lstrcat(kn, vdata);
						saveReg4(NULL, kn, &buf, &bsize);

						{
							TCHAR caption[MAX_PATH];

							wsprintf(caption, AllocLoadString(IDS_STATUS_SAVINGRELATIONOF_WROTE), exename, keyname);
							SetDlgItemText(dlg, IDC_PROCTEXT, caption);
						}
					}

					hfree(vdata);
				}
			}

			hfree(keyname);

			RegCloseKey(hcr);
			RegCloseKey(hreg);
		}
	}

	{
		TCHAR savefname[MAX_PATH];
		HANDLE hf = NULL;

		lstrcpy(savefname, outdir);
		cutEndYen(savefname);
		lstrcat(savefname, TEXT(".reg"));

		do
		{
			DWORD written;

			if((hf = CreateFile(savefname, GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL)) == INVALID_HANDLE_VALUE)
				goto Error;

			if(!WriteFile(hf, buf, lstrlen(buf) * sizeof(TCHAR), &written, NULL))
				written = 0;

			if(written < lstrlen(buf) * sizeof(TCHAR))
				goto Error;

			CloseHandle(hf);
			break;
Error:
			{
				DWORD le = GetLastError();
				if(hf)	CloseHandle(hf);
				hfree(buf);
				DestroyWindow(dlg);
				SetLastError(le);
			}
			return TRUE;
		}while(0);
	}

	hfree(buf);

	DestroyWindow(dlg);

	return FALSE;
}

// doTemplate: do something according with template.
//  fname: template file name
//  basedir: output base dir(terminated with "\" [backslash/yenmark])
// sample:
//  doTemplate("template\\some.txt", "e:\\backup\\");
//   ->make e:\backup\ somedir\0\...
BOOL doTemplate(LPCTSTR fname, LPCTSTR outdir, LPTSTR* batch, UINT* batchsize, LPTSTR* errorverbose, UINT* errorverbosesize, BOOL errordlg, BOOL useRegedit)
{
	HANDLE hf;
	char* tdata;
	DWORD read;
	BOOL errored = FALSE;

	// read template
	if((hf = CreateFile(fname, GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, 0, NULL)) == INVALID_HANDLE_VALUE)
	{
		char ts[256];

		wsprintf(ts, AllocLoadString(IDS_ERROR_CANTOPENTEMPLATEANDSKIP), fname);
		if(errordlg)
			MessageBox(NULL, ts, AllocLoadString(IDS_CAPTION_ERROR), MB_ICONWARNING | MB_OK);
		return TRUE;
	}
	if(!(tdata = halloc(GetFileSize(hf, NULL) + 1)))
	{
		CloseHandle(hf);
		return TRUE;
	}
	if(!ReadFile(hf, tdata, GetFileSize(hf, NULL), &read, NULL))
		read = 0;
	if(read != GetFileSize(hf, NULL))
	{
		char ts[256];

		wsprintf(ts, AllocLoadString(IDS_ERROR_CANTREADTEMPLATEANDSKIP), fname);
		if(errordlg)
			MessageBox(NULL, ts, AllocLoadString(IDS_CAPTION_ERROR), MB_ICONWARNING | MB_OK);
		CloseHandle(hf);
		hfree(tdata);
		return TRUE;
	}
	tdata[GetFileSize(hf, NULL)] = TEXT('\0');
	CloseHandle(hf);

	// do template
	{
		char* p = tdata;
		LPTSTR tpdir;
		LPTSTR param;
		UINT lines = 0;
		UINT count;
		TCHAR basedir[MAX_PATH];

		appendString(batch, batchsize, TEXT("ECHO Restoreing: "));
		appendString(batch, batchsize, GetLine(&p));	// title
		appendString(batch, batchsize, TEXT("\r\n"));
		GetLine(&p);	// desc
		tpdir = GetLine(&p);	// outdir

		lstrcpy(basedir, outdir);	// already added yen.
		lstrcat(basedir, tpdir);
		lstrcat(basedir, TEXT("\\"));
		makedir(basedir);

		// calculate lines
		{
			char* leader = p;

			while(SkipLine(&leader))
				lines++;
		}

		SendMessage(hProgress[1], PBM_SETRANGE, 0, MAKELPARAM(0, lines));
		SendMessage(hProgress[1], PBM_SETSTEP, 1, 0);
		SendMessage(hProgress[1], PBM_SETPOS, 0, 0);

		for(count = 0; param = GetLine(&p); count++)	//readline=readinstructure
		{
			char cmd = param[0];
			TCHAR destdir[MAX_PATH];

			if(param[1] != TEXT(':'))	// oops?
			{
				SendMessage(hProgress[1], PBM_STEPIT, 0, 0);
				continue;	// ignore
			}

			param += 2;

			lstrcpy(destdir, basedir);
			addEndYen(destdir);
			wsprintf(destdir, TEXT("%s%d\\"), destdir, count);

			// TODO: GetLastErrorCloseƂ̋AɂȂĂ̂ŏC
			switch(cmd)
			{
			case TEXT('F'):	
			case TEXT('S'):
				// &&ŐɊm肵͎sȂR[hfRpCłȂƑςȂƂɁB
				if((cmd == TEXT('F') && backupSubProc(param, destdir, FALSE)) || (cmd == TEXT('S') && backupSubProc(param, destdir, TRUE)))
				{
					errored = TRUE;
					appendString(errorverbose, errorverbosesize, AllocLoadString(IDS_ERROR_BACKUPFILEFAILED));
					appendString(errorverbose, errorverbosesize, TEXT(": "));
					appendString(errorverbose, errorverbosesize, param);
					appendString(errorverbose, errorverbosesize, TEXT(": "));
					{
						LPTSTR str;

						FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_IGNORE_INSERTS/*<-ꂢ?*/ | FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), 0, (LPTSTR)&str, 1, NULL);
						appendString(errorverbose, errorverbosesize, str);
						LocalFree(str);
					}
					appendString(errorverbose, errorverbosesize, TEXT("\r\n"));

					if(errordlg)
						MessageBox(NULL, param, AllocLoadString(IDS_ERROR_BACKUPFILEFAILED), MB_ICONERROR | MB_OK);
				}else
				{
					TCHAR path[MAX_PATH];

					appendString(batch, batchsize, TEXT("IF \"%FILE%\"==\"1\" xcopy \""));
					lstrcpy(path, tpdir);
					addEndYen(path);
					wsprintf(path, TEXT("%s%d\\*.*\" \""), path, count);
					appendString(batch, batchsize, path);
					lstrcpy(path, param);
					*(LPTSTR)basename(path) = TEXT('\0');
					expandPercents(path);
					addEndYen(path);	// ʂĂ邯ǔÔ
					appendString(batch, batchsize, path);
					appendString(batch, batchsize, TEXT("\" /e /c /q /h /r /k /y\r\n"));
				}
				break;
			case TEXT('R'):
				if(backupReg(param, destdir, useRegedit))
				{
					errored = TRUE;
					{
						LPTSTR str;
						DWORD le = GetLastError();

						appendString(errorverbose, errorverbosesize, AllocLoadString(IDS_ERROR_BACKUPREGFAILED));
						appendString(errorverbose, errorverbosesize, TEXT(": "));
						appendString(errorverbose, errorverbosesize, param);
						appendString(errorverbose, errorverbosesize, TEXT(": "));

						{
							TCHAR ts[16];

							wsprintf(ts, "(%d)", le);
							appendString(errorverbose, errorverbosesize, ts);
						}

						FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_IGNORE_INSERTS/*<-ꂢ?*/ | FORMAT_MESSAGE_FROM_SYSTEM, NULL, le, 0, (LPTSTR)&str, 1, NULL);
						appendString(errorverbose, errorverbosesize, str);
						LocalFree(str);
					}
					appendString(errorverbose, errorverbosesize, TEXT("\r\n"));

					if(errordlg)
						MessageBox(NULL, param, AllocLoadString(IDS_ERROR_BACKUPREGFAILED), MB_ICONERROR | MB_OK);
				}else
				{
					TCHAR regfn[MAX_PATH];

					lstrcpy(regfn, tpdir);
					addEndYen(regfn);
					wsprintf(regfn, TEXT("%s%d.reg"), regfn, count);

					appendString(batch, batchsize, TEXT("IF \"%REGI%\"==\"1\" regedit /s \""));
					appendString(batch, batchsize, regfn);
					appendString(batch, batchsize, TEXT("\"\r\n"));
				}
				break;
			case TEXT('X'):
				if(backupRelation(param, destdir, useRegedit))
				{
					errored = TRUE;
					appendString(errorverbose, errorverbosesize, AllocLoadString(IDS_ERROR_BACKUPRELATIONFAILED));
					appendString(errorverbose, errorverbosesize, TEXT(": "));
					appendString(errorverbose, errorverbosesize, param);
					appendString(errorverbose, errorverbosesize, TEXT(": "));
					{
						LPTSTR str;

						FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_IGNORE_INSERTS/*<-ꂢ?*/ | FORMAT_MESSAGE_FROM_SYSTEM, NULL, GetLastError(), 0, (LPTSTR)&str, 1, NULL);
						appendString(errorverbose, errorverbosesize, str);
						LocalFree(str);
					}
					appendString(errorverbose, errorverbosesize, TEXT("\r\n"));

					if(errordlg)
						MessageBox(NULL, param, AllocLoadString(IDS_ERROR_BACKUPRELATIONFAILED), MB_ICONERROR | MB_OK);
				}else
				{
					TCHAR regfn[MAX_PATH];

					lstrcpy(regfn, tpdir);
					addEndYen(regfn);
					wsprintf(regfn, TEXT("%s%d.reg"), regfn, count);

					appendString(batch, batchsize, TEXT("IF \"%REGI%\"==\"1\" regedit /s \""));
					appendString(batch, batchsize, regfn);
					appendString(batch, batchsize, TEXT("\"\r\n"));
				}
				break;
			case TEXT('I'):
				MessageBox(NULL, TEXT("INIbackup has not been supported yet. "), AllocLoadString(IDS_CAPTION_ERROR), MB_ICONERROR | MB_OK);
				break;
			default:
				{
					char ts[256];

					wsprintf(ts, AllocLoadString(IDS_ERROR_UNKNOWNCOMMAND), cmd);

					errored = TRUE;
					appendString(errorverbose, errorverbosesize, ts);
					appendString(errorverbose, errorverbosesize, TEXT("\r\n"));

					if(errordlg)
						MessageBox(NULL, ts, AllocLoadString(IDS_CAPTION_ERROR), MB_ICONWARNING | MB_OK);
				}
				break;
			}

			SendMessage(hProgress[1], PBM_STEPIT, 0, 0);
		}

		appendString(batch, batchsize, TEXT("\r\n"));
	}

	// free
	hfree(tdata);

	return errored;
}
