#include "common.h"
#include "rkeyslct.h"

LPTSTR GetTreeViewItemText(HWND hWnd, HTREEITEM hti)
{
	LPTSTR tx;
	int tsz = 256;

	while(1)
	{
		TV_ITEM ti;
		ti.mask = TVIF_TEXT;
		ti.hItem = hti;
		tx = halloc(tsz * sizeof(TCHAR));
		ti.pszText = tx;
		ti.cchTextMax = tsz;
		tx[0] = '\0';
		TreeView_GetItem(hWnd, &ti);
		tx[tsz - 1] = '\0';
		if(lstrlen(tx) != tsz - 1)
			break;

		hfree(tx);
		tsz *= 2;
	}

	return tx;
}

LPTSTR ConnectTreeItemTextCallback(HWND hWnd, HTREEITEM hti, TCHAR connector, LPTSTR* tx, DWORD* txsz)
{
	HTREEITEM htpi;
	LPTSTR itx;

	if(hti == NULL || hti == TVI_ROOT)
	{
		newString(tx, txsz);
		return *tx;
	}
	
	htpi = TreeView_GetParent(hWnd, hti);
	ConnectTreeItemTextCallback(hWnd, htpi, connector, tx, txsz);

	itx = GetTreeViewItemText(hWnd, hti);
	appendString(tx, txsz, itx);
	appendChar(tx, txsz, connector);
	hfree(itx);

	return *tx;
}

LPTSTR ConnectTreeItemText(HWND hWnd, HTREEITEM hti, TCHAR connector)
{
	LPTSTR tx = NULL;
	DWORD txsz;

	ConnectTreeItemTextCallback(hWnd, hti, connector, &tx, &txsz);

	if(lastchar(tx, connector))
		*(LPTSTR)lastchar(tx, connector) = TEXT('\0');

	return tx;
}

BOOL CALLBACK RegKeyReferenceDlgProc(HWND hWnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch(msg)
	{
	case WM_INITDIALOG:
		// [gL[ǉ
		{
			TVINSERTSTRUCT tvis;
			LV_COLUMN lvc;
			// TODO: ACR: SetImageListTVIF_IMAGEiImageB

			tvis.hParent = TVI_ROOT;
			tvis.hInsertAfter = TVI_LAST;
			tvis.item.mask = TVIF_TEXT | TVIF_PARAM;
			tvis.item.lParam = 1;

			// for debug
			tvis.item.mask |= TVIF_CHILDREN;
			tvis.item.cChildren = 1;

			tvis.item.pszText = TEXT("HKEY_CLASSES_ROOT");
			TreeView_InsertItem(GetDlgItem(hWnd, IDC_REGTREE), &tvis);

			tvis.item.pszText = TEXT("HKEY_CURRENT_USER");
			TreeView_InsertItem(GetDlgItem(hWnd, IDC_REGTREE), &tvis);

			tvis.item.pszText = TEXT("HKEY_LOCAL_MACHINE");
			TreeView_InsertItem(GetDlgItem(hWnd, IDC_REGTREE), &tvis);

			tvis.item.pszText = TEXT("HKEY_USERS");
			tvis.hParent = TreeView_InsertItem(GetDlgItem(hWnd, IDC_REGTREE), &tvis);
			tvis.item.pszText = TEXT("TEST");
			TreeView_InsertItem(GetDlgItem(hWnd, IDC_REGTREE), &tvis);

			// TODO: PERFORMANCE_DATA DYN_DATA etc. are not supported yet.Ȃ?

			lvc.mask = LVCF_TEXT | LVCF_WIDTH;
			// TODO: use StringTable
			lvc.cx = 100;
			lvc.pszText = (LPTSTR)AllocLoadString(IDS_HEAD_REGNAME);
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_REGLIST), 0, &lvc);
			lvc.cx = 60;
			lvc.pszText = (LPTSTR)AllocLoadString(IDS_HEAD_REGTYPE);
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_REGLIST), 1, &lvc);
			lvc.cx = 100;
			lvc.pszText = (LPTSTR)AllocLoadString(IDS_HEAD_REGVALUE);
			ListView_InsertColumn(GetDlgItem(hWnd, IDC_REGLIST), 2, &lvc);
		}
		return TRUE;
	case WM_COMMAND:
		switch(LOWORD(wp))
		{
		case IDOK:
			// TODO: stub: return selected
			EndDialog(hWnd, (int)ConnectTreeItemText(GetDlgItem(hWnd, IDC_REGTREE), TreeView_GetSelection(GetDlgItem(hWnd, IDC_REGTREE)), TEXT('\\')));
			break;
		case IDCANCEL:
			EndDialog(hWnd, 0);
			break;
		}
		break;
	case WM_NOTIFY:
		{
			NMHDR* nmh = (NMHDR*)lp;

			switch(nmh->code)
			{
			case TVN_ITEMEXPANDING:
				{
					NM_TREEVIEW* nmtv = (NM_TREEVIEW*)lp;

					// TODO: BUG: EXPANDEDONCEČĂ銄2قǂłǁBdȂ̂lParamŁB
					if((nmtv->action == TVE_EXPAND) && !(nmtv->itemNew.state & TVIS_EXPANDEDONCE) && nmtv->itemNew.lParam)
					{
						TV_INSERTSTRUCT tvis;
						LPTSTR tx;
						HKEY hk, hreg;

						if(!nmtv->itemNew.hItem)
							break;	//MessageBox(NULL, "ERROR", "ERROR", MB_OK);

						// ǃtOZbg
						{
							TV_ITEM tvi;

							tvi.mask = TVIF_PARAM;
							tvi.lParam = 0;
							tvi.hItem = nmtv->itemNew.hItem;
							TreeView_SetItem(nmh->hwndFrom, &tvi);
						}

						tvis.hParent = nmtv->itemNew.hItem;
						tvis.hInsertAfter = TVI_SORT;
						tvis.item.mask = TVIF_TEXT | TVIF_CHILDREN | TVIF_PARAM;
						tvis.item.lParam = 1;

						tx = ConnectTreeItemText(GetDlgItem(hWnd, IDC_REGTREE), nmtv->itemNew.hItem, TEXT('\\'));
						hk = getHKeyFromString(tx);

						if(RegOpenKeyEx(hk, CharNextX(lstrchr(tx, TEXT('\\'))), 0, KEY_READ, &hreg))
						{
							MessageBox(hWnd, AllocLoadString(IDS_ERROR_CANTOPENREGKEY), AllocLoadString(IDS_CAPTION_ERROR), MB_ICONERROR | MB_OK);
							SetWindowLong(hWnd, DWL_MSGRESULT, TRUE);
							return TRUE;
						}

						{
							LPTSTR kn;
							DWORD knmaxsize, keynum;
							DWORD i;

							RegQueryInfoKey(hreg, NULL, NULL, NULL, &keynum, &knmaxsize, NULL, NULL, NULL, NULL, NULL, NULL);
							kn = halloc((knmaxsize + 1) * 2);

							SetCursor(LoadCursor(NULL, IDC_WAIT));

							for(i = 0; i < keynum; i++)
							{
								RegEnumKey(hreg, i, kn, (knmaxsize + 1) * 2);

								{
									HKEY hr;

									RegOpenKeyEx(hreg, kn, 0, KEY_READ, &hr);
									RegQueryInfoKey(hr, NULL, NULL, NULL, &tvis.item.cChildren, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
									RegCloseKey(hr);
								}

								tvis.item.pszText = kn;
								TreeView_InsertItem(GetDlgItem(hWnd, IDC_REGTREE), &tvis);
							}

							SetCursor(LoadCursor(NULL, IDC_ARROW));

							hfree(kn);
						}

						RegCloseKey(hreg);

						return TRUE;
					}
				}
				break;
			case TVN_SELCHANGED:
				{
					NM_TREEVIEW* nmtv = (NM_TREEVIEW*)lp;
					LPTSTR valname;
					DWORD valnamems;
					BYTE* valdata;
					DWORD valdatams;
					DWORD valnum, i;
					HKEY hroot, hreg;
					LPTSTR regpath;

					regpath = ConnectTreeItemText(GetDlgItem(hWnd, IDC_REGTREE), nmtv->itemNew.hItem, TEXT('\\'));

					hroot = getHKeyFromString(regpath);
					if(RegOpenKeyEx(hroot, CharNextX(lstrchr(regpath, TEXT('\\'))), 0, KEY_READ, &hreg))
					{
						MessageBox(hWnd, AllocLoadString(IDS_ERROR_CANTOPENREGKEY), AllocLoadString(IDS_CAPTION_ERROR), MB_ICONERROR | MB_OK);
						hfree(regpath);
						break;
					}

					RegQueryInfoKey(hreg, NULL, NULL, NULL, NULL, NULL, NULL, &valnum, &valnamems, &valdatams, NULL, NULL);

					valnamems = (valnamems + 1) * 2;
					valdatams = (valdatams + 1) * 2;
					valname = halloc(valnamems);
					valdata = halloc(valdatams);

					ListView_DeleteAllItems(GetDlgItem(hWnd, IDC_REGLIST));

					SetCursor(LoadCursor(NULL, IDC_WAIT));

					for(i = 0; i < valnum; i++)
					{
						DWORD valnames = valnamems;
						DWORD valdatas = valdatams;
						DWORD valtype;
						LV_ITEM lvi;
						TCHAR ts[64];

						RegEnumValue(hreg, i, valname, &valnames, NULL, &valtype, valdata, &valdatas);

						lvi.mask = LVIF_TEXT;
						lvi.iItem = i;
						lvi.iSubItem = 0;
						lvi.pszText = valname;
						ListView_InsertItem(GetDlgItem(hWnd, IDC_REGLIST), &lvi);

						lvi.iSubItem = 1;
						lvi.pszText = ts;
						switch(valtype)
						{
						case REG_SZ:		lstrcpy(ts, TEXT("REG_SZ"));		break;
						case REG_EXPAND_SZ:	lstrcpy(ts, TEXT("REG_EXPAND_SZ"));	break;
						case REG_MULTI_SZ:	lstrcpy(ts, TEXT("REG_MULTI_SZ"));	break;
						case REG_DWORD:		lstrcpy(ts, TEXT("REG_DWORD"));		break;
						case REG_BINARY:	lstrcpy(ts, TEXT("REG_BINARY"));	break;
						case REG_QWORD:		lstrcpy(ts, TEXT("REG_QWORD"));		break;
						default:			wsprintf(ts, TEXT("%d"), valtype);	break;
						}
						ListView_SetItem(GetDlgItem(hWnd, IDC_REGLIST), &lvi);

						lvi.iSubItem = 2;
						switch(valtype)
						{
						case REG_SZ:
						case REG_EXPAND_SZ:
						case REG_MULTI_SZ:
							lvi.pszText = valdata;
							break;
						case REG_DWORD:
							wsprintf(ts, TEXT("0x%08X(%d)"), *(DWORD*)valdata, *(DWORD*)valdata);
							lvi.pszText = ts;
							break;
						default:
							//hexalize
							{
								int j, max;

								max = 16 < valdatas ? 16 : valdatas;
								ts[0] = TEXT('\0');

								for(j = 0; j < max; j++)
									wsprintf(ts, TEXT("%s%02X "), ts, valdata[j]);
								if(16 < valdatas)
									lstrcat(ts, TEXT("..."));
								lvi.pszText = ts;
							}
							break;
						}
						ListView_SetItem(GetDlgItem(hWnd, IDC_REGLIST), &lvi);
					}

					SetCursor(LoadCursor(NULL, IDC_ARROW));

					hfree(valname);
					hfree(valdata);

					RegCloseKey(hreg);

					hfree(regpath);
				}
				break;
			}
		}
		break;
	}

	return FALSE;
}

LPTSTR RegKeySelectDlg(HWND hWndParent)
{
	return (LPTSTR)DialogBoxParam(GetModuleHandle(NULL), MAKEINTRESOURCE(IDD_REGKEYREFERENCE), hWndParent, RegKeyReferenceDlgProc, 0);
}
